/**
 * Copyright 2019 DH
 * All right reserved.
 * 项目名称: 大恒泰山系统
 * 创建日期:2022/8/22
 */
package org.springblade.modules.baseinfo.region.wrapper;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.modules.baseinfo.region.entity.RegionInfoEntity;
import org.springblade.modules.baseinfo.region.service.IBaseRegionService;
import org.springblade.modules.baseinfo.region.vo.RegionInfoVO;


import java.util.Objects;

/***
 * Date:2022/8/22
 * Title:文件所属模块（必须填写）
 * Description：对本文件的详细描述，原则上不能少于30字
 * @author dylan
 * @version 1.0
 * Remark：认为有必要的其他信息
 */
public class RegionInfoWrapper extends BaseEntityWrapper<RegionInfoEntity, RegionInfoVO> {

	private static IBaseRegionService baseInfoRegionService;

	private static IBaseRegionService getBaseRegionService() {
		if (baseInfoRegionService == null) {
			baseInfoRegionService = SpringUtil.getBean(IBaseRegionService.class);
		}
		return baseInfoRegionService;
	}

	public static RegionInfoWrapper build() {
		return new RegionInfoWrapper();
	}

	@Override
	public RegionInfoVO entityVO(RegionInfoEntity entity) {
		if (null != entity) {
			RegionInfoVO regionInfoVO = Objects.requireNonNull(BeanUtil.copy(entity, RegionInfoVO.class));
			regionInfoVO.setCode(entity.getAdcd());
			regionInfoVO.setName(entity.getAdnm());

			RegionInfoEntity parentEntity = getBaseRegionService().getByCode(entity.getParentCode());
			if (null != parentEntity) {
				regionInfoVO.setParentId(parentEntity.getAdcd());
				regionInfoVO.setParentName(parentEntity.getAdnm());
			}
			return regionInfoVO;
		}
		return null;
	}

}
